#!/usr/bin/perl -w

use strict;

sub transform_cycle_line()
{
  my $cycle=$_[0];
  my $obj=$_[1];
  my $locs=$_[2];
  my $evts=$_[3];

  my $ret="$cycle & ";

  my @O=split(/,\s*/, $obj);
  for(my $i=0; $i<scalar(@O); $i++)
  {
    $O[$i] =~ s/_/\\_/g;
  }
  $ret.=join(", ", @O) . " & ";

  my $src="$locs & $evts";
  $src =~ s/_/\\_/g;

  while($src =~ /http:\/\//)
  {
    ($src =~ /^(.*)http:\/\/sources\.debian\.net\/src\/[^\/]+\/[^\/]+\/([^\?]+?)(\?.*?#L(\d+))(\s+.*)?$/)
      or die "Unexpected URL format in $src\n";
    my $pre=$1;
    my $fn=$2;
    my $hl=$3;
    my $ln=$4;
    my $suff="";
    $suff=$5 if(defined($5));
    $src="$pre\\ahref{\\".$ENV{URLNAME}."/".$fn.$hl."}{".$fn.":".$ln."}$suff";
  }

  return "$ret$src \\\\ \\hline\n";
}

sub transform_full_line()
{
  my $s=$_[0];
  my $n=$_[1];

  return "$s & $n & \\ahref{pkg-$ENV{PKG}-$s.html}{all $s instances} & "
    .  &transform_cycle_line($_[2], $_[3], $_[4], $_[5]);
}

while(<>)
{
  chomp;
  if(/^\s*(\S+)\s*\|\s*(\d+)\s*\|\s*([^\|]+)\s*\|\s*([^\|]*)\s*\|\s*([^\|]*)\s*\|\s*([^\|]+)\s*$/)
  {
    my $shape=$1;
    my $n=$2;
    my $cycle=$3;
    my $obj=$4;
    my $locs=$5;
    my $evts=$6;

    print &transform_full_line($shape, $n, $cycle, $obj, $locs, $evts);
  }
  elsif(/^\s*([^\|]+)\s*\|\s*([^\|]*)\s*\|\s*([^\|]*)\s*\|\s*([^\|]+)\s*$/)
  {
    my $cycle=$1;
    my $obj=$2;
    my $locs=$3;
    my $evts=$4;

    print &transform_cycle_line($cycle, $obj, $locs, $evts);
  }
  else
  {
    die "Invalid input format in $_\n";
  }
}

