#!/usr/bin/perl -w

use strict;

my %known=();

sub transform_line()
{
  my @cycle=split(/\s/, $_[0]);
  my $c=0;

  my $l=$_[1];
  my %O=();
  my %L=();
  my @full=();

  while($l =~ /^\s*(f|F|asm|c::\S+)\s+\(([^\)]+)\)(.*)$/)
  {
    my $obj=$1;
    my $loc=$2;
    $l=$3;
    if(!($obj =~ /^(f|F|asm)$/))
    {
      $obj =~ s/^c:://;
      $O{$obj}=1;
      if($cycle[$c] =~ /^(DpData..|Po.R.|Fr.|LwSync.R.|Sync.R.)$/)
      {
        push @full, "R:$obj";
      }
      else
      {
        ($cycle[$c] =~ /^(Po.W.|Rf.|Ws.|LwSync.W.|Sync.W.)$/) or
          die "Missing relation $cycle[$c]\n";
        push @full, "W:$obj";
      }
      $c++ if(!($cycle[$c] =~ /^(Lw)?Sync...$/));
    }
    else
    {
      push @full, $obj;
      $c++ if($l =~ /^\s*c::/);
    }

    if(!($loc =~ /^file (.+) line (\d+) function (\S+) thread (\d+)$/))
    {
      push @full, "($loc)";
      next;
    }

    my $fn=$1;
    my $ln=$2;
    my $func=$3;
    my $thread=$4;

    $fn =~ s/\/srv\/jenkins-workspace\/goto-cc-$ENV{PKG}\/[^\/]+\///;

    if(!defined($known{$fn}))
    {
      my $ffn=$fn;
      $ffn =~ s/.*\.\.\///;
      $ffn=`find mole-pkg -type f | grep "$ffn\$"`;
      chomp $ffn;
      if($ffn eq "" || $ffn =~ /\n/)
      {
        $ffn=$fn;
      }
      else
      {
        $ffn =~ s/^mole-pkg\/[^\/]+//;
        $ffn="http://sources.debian.net/src/$ENV{PKG}/$ENV{PKG_VERSION}$ffn";
      }
      defined($L{$ffn}) or $L{$ffn}=();
      $known{$fn}=$ffn;
    }

    $fn=$known{$fn};

    $L{$fn}{$ln}=1 if(!($obj =~ /^(LwSync|Sync)$/));

    if($fn =~ /^http:/)
    {
      push @full, "($fn?hl=$ln#L$ln function $func thread $thread)";
    }
    else
    {
      push @full, "($fn:$ln function $func thread $thread)";
    }
  }

  print join(" ", @cycle) . " | ";
  print join(", ", sort keys %O) . " |";
  for my $f (keys %L)
  {
    my $hl_string="?hl=" . join(",", sort keys %{ $L{$f} });
    for my $lno (keys %{ $L{$f} })
    {
      print " $f";
      if($f =~ /^http:/)
      {
        print "$hl_string#L$lno";
      }
      else
      {
        print ":$lno";
      }
    }
  }
  print " | " . join(" ", @full) . "\n";
}

while(<>)
{
  chomp;
  (/^(.+);(.+)$/) or die "Invalid input $_\n";

  my $source=$1;
  my $cycle=$2;

  &transform_line($cycle, $source);
}

