#!/bin/bash

set -e

MOLE_HOME=`cd \`dirname $0\` > /dev/null 2>&1 ; echo $PWD`

rm -rf mole-report
mkdir mole-report

cat > mole-report/mole.tex <<EOF
\\documentclass{article}
\\usepackage{url}
\\usepackage{hevea}

\\begin{document}
EOF

for p in `ls cycles-proc` ; do
  [ -e cycles-proc/$p/classify-done ] || continue 
  if [ ! -e cycles-proc/$p/mole-report.txt ] ; then
    echo "Generating report for $p"
    $MOLE_HOME/mole.sh $p
  fi
  if [ ! -e cycles-proc/$p/mole-report.tex ] ; then
    echo "Generating LaTeX report for $p"
    $MOLE_HOME/mole-to-latex.sh $p
  fi
  echo "$p"
  for f in cycles-proc/$p/mole-report*.tex ; do
    t=`basename $f .tex | sed "s/mole-report/pkg-$p/"`
    if [ "$t" = "pkg-$p" ] ; then
      cp $f mole-report/$t.tex
    else
      if ! timeout 30 hevea $f -o mole-report/$t.html ; then
        rm -f mole-report/$t.html
        cp $f mole-report/$t.tex
      fi
    fi
  done
  echo "\\include{pkg-$p}" >> mole-report/mole.tex
done

cat >> mole-report/mole.tex <<EOF
\\end{document}
EOF

